#include <stdio.h>

static unsigned tsc(void)
{
  unsigned long long c;
  asm volatile ("rdtsc":"=A"(c));
  return c;
}

#define N (1000 * 1000)

int main()
{
  int i;
  unsigned carib;
  unsigned c;

  carib = tsc();
  carib = tsc() - carib;

  c = tsc();
  for (i = 0; i < N / 4; i++)
    asm volatile ("xorps %%xmm0,%%xmm0;"
		  "xorps %%xmm1,%%xmm1;"
		  "xorps %%xmm2,%%xmm2;"
		  "xorps %%xmm3,%%xmm3"
		  :::"%xmm0", "xmm1", "xmm2", "xmm3");
  c = tsc() - c;
  printf("xorps\t%11d\n", c - carib);

  c = tsc();
  for (i = 0; i < N / 4; i++)
    asm volatile ("movaps %%xmm4,%%xmm0;"
		  "movaps %%xmm4,%%xmm1;"
		  "movaps %%xmm4,%%xmm2;"
		  "movaps %%xmm4,%%xmm3"
		  :::"%xmm0", "xmm1", "xmm2", "xmm3");
  c = tsc() - c;
  printf("movaps\t%11d\n", c - carib);

  c = tsc();
  for (i = 0; i < N / 4; i++)
    asm volatile ("pxor %%xmm0,%%xmm0;"
		  "pxor %%xmm1,%%xmm1;"
		  "pxor %%xmm2,%%xmm2;"
		  "pxor %%xmm3,%%xmm3"
		  :::"%xmm0", "xmm1", "xmm2", "xmm3");
  c = tsc() - c;
  printf("pxor\t%11d\n", c - carib);

  c = tsc();
  for (i = 0; i < N / 4; i++)
    asm volatile ("movdqa %%xmm4,%%xmm0;"
		  "movdqa %%xmm4,%%xmm1;"
		  "movdqa %%xmm4,%%xmm2;"
		  "movdqa %%xmm4,%%xmm3"
		  :::"%xmm0", "xmm1", "xmm2", "xmm3");
  c = tsc() - c;
  printf("movdqa\t%11d\n", c - carib);

  return 0;
}
